/*
** JabberX (Jabber Client)
** Copyright (c) 2002 Evan Prodromou <misterbad@users.sourceforge.net>
**
** This code is free software; you can redistribute it and/or
** modify it under the terms of the GNU General Public License.
**
** time functions.
*/

#include "common.h"
#include <time.h>

/* YYYYMMDDTHH:MM:SS */

#define UTC_SIZE 18

void cmd_time(char *arg)
{
	iks *x;
	char *to;

	if(strlen(arg))
		to = arg;
	else
                to = net.id->server;

	x = iks_make_iq(IKS_TYPE_GET, IKS_NS_TIME);
	iks_insert_attrib(x, "to", to);
	iks_send(net.parser, x);
	iks_delete(x);
}

void send_time(iksid *to)
{
        iks *x, *y;
        time_t t = time(NULL);
        struct tm * gm = gmtime(&t);
        char utc[UTC_SIZE];
        struct tm * lo = localtime(&t);
        int tzi = (lo->tm_isdst) ? 1 : 0;
        char *tz = strdup(tzname[tzi]); /* copy these static items */
        char *at = strdup(asctime(lo));

        char *atnl = strchr(at, '\n');
        *atnl = (char) 0;

        x = iks_make_iq(IKS_TYPE_RESULT, IKS_NS_TIME);
        iks_insert_attrib(x, "to", iks_id_print(to));

        y = iks_find(x, "query");

        sprintf(utc, "%04d%02d%02dT%02d:%02d:%02d",
                gm->tm_year + 100,
                gm->tm_mon + 1,
                gm->tm_mday,
                gm->tm_hour,
                gm->tm_min,
                gm->tm_sec);

        iks_insert_cdata(iks_insert(y, "utc"), utc, UTC_SIZE);
        /* FIXME: asctime has \n, use strftime() instead */
        iks_insert_cdata(iks_insert(y, "display"), at, -1);
        /* FIXME: Long timezone name */
        iks_insert_cdata(iks_insert(y, "tz"), tz, -1);

        iks_send(net.parser, x);
        iks_delete(x);

        free(tz);
        free(at);
}

void time_parse(ikspak *pak)
{
        iks* x;

	gui_attr(GA_NOTICE);

	x = iks_child(pak->x);
	gui_print("Time result from '%s':\n", iks_id_print(pak->from));

	x = iks_child(x);
	while(x)
	{
		if(iks_type(x) == IKS_TAG)
		{
                         gui_print("-> %s: %s\n", iks_name(x), iks_cdata(iks_child(x)));
		}

		x = iks_next(x);
	}

        if (!options.compact_lines)
          gui_print ("\n");
}
