/*
** JabberX (Jabber Client)
** Copyright (c) 2002 Evan Prodromou <misterbad@users.sourceforge.net>
**
** This code is free software; you can redistribute it and/or
** modify it under the terms of the GNU General Public License.
**
** version query, response
*/

#include "common.h"
#include <sys/utsname.h>

void cmd_version(char *arg)
{
	iks *x;
	char *to;
        struct utsname un;

	if(arg && strlen(arg))
        {
                to = arg;
	        x = iks_make_iq(IKS_TYPE_GET, IKS_NS_VERSION);
  	        iks_insert_attrib(x, "to", to);
	        iks_send(net.parser, x);
	        iks_delete(x);
        }
	else
        {
                 uname(&un);

                 gui_attr(GA_NOTICE);

                 gui_print("Local version info:\n");
                 gui_print("%s %s (%s)\n", "JabberX", VERSION, un.sysname);

                 if (!options.compact_lines)
                           gui_print("\n");
        }
}

void send_version(iksid *to) 
{
         struct utsname un;
         iks *x, *y;
         x = iks_make_iq(IKS_TYPE_RESULT, IKS_NS_VERSION);
         iks_insert_attrib(x, "to", iks_id_print(to));
         y = iks_find(x, "query");
         iks_insert_cdata(iks_insert(y, "name"), "JabberX", 7);
         iks_insert_cdata(iks_insert(y, "version"), VERSION, -1);
         uname(&un);
         iks_insert_cdata(iks_insert(y, "os"), un.sysname, -1);
         iks_send(net.parser, x);
         iks_delete(x);
}

void version_parse(ikspak *pak)
{
	iks *x;

	gui_attr(GA_NOTICE);

	gui_print("Version result from '%s':\n", iks_id_print(pak->from));
	x = iks_find(pak->x, "query");

	gui_print("%s %s (%s)\n", iks_find_cdata(x, "name"), iks_find_cdata(x, "version"),
                                  iks_find_cdata(x, "os"));

        if (!options.compact_lines)
               gui_print("\n");
}

void version_error(ikspak *pak)
{
         iks *x;

         gui_attr(GA_NOTICE);
         gui_print("Version result from '%s':\n", iks_id_print(pak->from));
         x = iks_find(pak->x, "error");
         if(x)
         {
           gui_print("Error %s: %s.\n", iks_find_attrib(x, "code"), iks_cdata(iks_child(x)));
           if (!options.compact_lines)
             gui_print ("\n");
         }
}
